//---------------------------------------------------------------------------

#ifndef DemoDlgH
#define DemoDlgH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TMainWindow : public TForm
{
__published:	// IDE-managed Components
	TGroupBox *screen_capture;
	TRadioButton *full_screen;
	TRadioButton *a_region_window;
	TRadioButton *pc_game_screen;
	TGroupBox *audio_capture;
	TCheckBox *playback_audio;
	TCheckBox *microphone_audio;
	TGroupBox *webcam_capture;
	TCheckBox *webcam_preview;
	TCheckBox *webcam_overlay;
	TCheckBox *full_webcam_video;
	TGroupBox *output_video;
	TEdit *video_path;
	TButton *change_video_path;
	TButton *browse_video_path;
	TLabel *rec_time;
	TButton *start_stop;
	TButton *pause_resume;
	TButton *more_settings;
	TTimer *timer_REC;
	TTimer *timer_FPS;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall timer_RECTimer(TObject *Sender);
	void __fastcall timer_FPSTimer(TObject *Sender);
	void __fastcall start_stopClick(TObject *Sender);
	void __fastcall pause_resumeClick(TObject *Sender);
	void __fastcall more_settingsClick(TObject *Sender);
	void __fastcall change_video_pathClick(TObject *Sender);
	void __fastcall browse_video_pathClick(TObject *Sender);
	void __fastcall full_screenClick(TObject *Sender);
	void __fastcall a_region_windowClick(TObject *Sender);
	void __fastcall pc_game_screenClick(TObject *Sender);
	void __fastcall playback_audioClick(TObject *Sender);
	void __fastcall microphone_audioClick(TObject *Sender);
	void __fastcall webcam_previewClick(TObject *Sender);
	void __fastcall webcam_overlayClick(TObject *Sender);
	void __fastcall full_webcam_videoClick(TObject *Sender);
private:	// User declarations
	TBitmap *m_dibFPS;
	void Init_Game_FPS_Overlay(void);
	void Free_Game_FPS_Overlay(void);
	void Update_Game_FPS_Overlay(void);
	void Update_UI(void);
	void Start_Recording(void);
	void Stop_Recording(BOOL bSuccessful);
public:		// User declarations
	__fastcall TMainWindow(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainWindow *MainWindow;
//---------------------------------------------------------------------------
#endif
